/*----------------------------------------------------------------
 * Copyright (C) 2011 մѧ ѧԺ416 ԭ
 * ȨС 
 * 
 * ļ DMA.c
 * 
 * ļ   
 *          MSP430F16xϵеƬDMA
 *      ˵  
 *          óDMAģͨó⣬ñDMA
 *          ʹDMAԼҪʱ亯
 *      ʹ÷ʽ
 *          м뱾ļDMA.cԴļDMA.hȻ
 *          ӦDMAõȹܡ
 *          
 * ʶ   ԭ20110829
 * 
 * ޸ıʶ   
 * ޸   
**----------------------------------------------------------------*/

#include <msp430x16x.h>
#include "DMA.h"

/************************************************************
* ƣDMAInit
*     ܣDMAõؼĴԴʼ
*     channel:ͨ 0 1 2
*           triggerԴ 
        Դ0000    DMAREQ bit (software trigger)
                0001    TACCR2 CCIFG bit
                0010    TBCCR2 CCIFG bit
                0011    URXIFG0 (UART/SPI mode), USART0 data received (I2C mode)
                0100    UTXIFG0 (UART/SPI mode), USART0 transmit ready (I2C mode)
                0101    DAC12_0CTL DAC12IFG bit
                0110    ADC12 ADC12IFGx bit
                0111    TACCR0 CCIFG bit
                1000    TBCCR0 CCIFG bit
                1001    URXIFG1 bit
                1010    UTXIFG1 bit
                1011    Multiplier ready
                1100    No action
                1101    No action
                1110    DMA0IFG bit triggers DMA channel 1
                        DMA1IFG bit triggers DMA channel 2
                        DMA2IFG bit triggers DMA channel 0
                1111    External trigger DMAE0
*           transModeģʽ
                'S'δ   's'ظδ(single)
                'B'鴫     'b'ظ鴫(block)
                'I'ͻ鴫 'i'ظͻ鴫(interleaved) 
*           srcModeԴַģʽ
                0   000ִ䣬ַ
                1   001ִ䣬ַ
                2   010ִ䣬ַݼ
                3   011ִ䣬ַ
                4   100ֽڴ䣬ַ
                5   101ֽڴ䣬ַ
                6   110ֽڴ䣬ַݼ
                7   111ֽڴ䣬ַ
*           dstModeĿĵַģʽ ȡֵͬsrcMode
*           srcԴַ 16λ
*           dstĿĵַ 16λ
*           sizeÿֽڻ 
*   ֵ
* ˵    ô˺öӦDMAͨزĬ
            £DMAʱCPUǰָɺӦ 
            ˳̶ DMA0-2ͨȼͣ ⲿNMI
            DMA䣻DMAжϣشDMA䡣
            Ҫиġ
* ʾ    DMAInit(0,0x01,'s',0,1,0x0240,0x0220,1): ֵ
             ִ䡣
*************************************************************/
void DMAInit(char channel,char trigger,char transMode,char srcMode,char dstMode,
             unsigned int src,unsigned int dst,unsigned int size)
{
    unsigned int *DMAxCTL,*DMAxSA,*DMAxDA,*DMAxSZ;
    
    DMACTL0 = trigger << (channel << 2);
    DMACTL1 = 0x04;         //DMAյʱȴǰִָɺ
    
    switch (channel)        //ѡǰĸDMAͨ
    {
        case 0: 
            DMAxCTL = (unsigned int *)&DMA0CTL;
            DMAxSA = (unsigned int *)&DMA0SA;
            DMAxDA = (unsigned int *)&DMA0DA;
            DMAxSZ = (unsigned int *)&DMA0SZ;
            break;                                      //ָ = 0ͨ
        case 1: 
            DMAxCTL = (unsigned int *)&DMA1CTL;
            DMAxSA = (unsigned int *)&DMA1SA;
            DMAxDA = (unsigned int *)&DMA1DA;
            DMAxSZ = (unsigned int *)&DMA1SZ;
            break;                                      //ָ = 1ͨ
        case 2: 
            DMAxCTL = (unsigned int *)&DMA2CTL;
            DMAxSA = (unsigned int *)&DMA2SA;
            DMAxDA = (unsigned int *)&DMA2DA;
            DMAxSZ = (unsigned int *)&DMA2SZ;
            break;                                      //ָ = 2ͨ
    }
    
    switch (transMode)      //DMAͨĴģʽ
    {
        case 'S': *DMAxCTL = DMADT_0;   break;          //δ
        case 's': *DMAxCTL = DMADT_4;   break;          //ظδ
        case 'B': *DMAxCTL = DMADT_1;   break;          //鴫
        case 'b': *DMAxCTL = DMADT_5;   break;          //ظ鴫
        case 'I': *DMAxCTL = DMADT_2;   break;          //ͻ鴫 
        case 'i': *DMAxCTL = DMADT_6;   break;          //ظͻ鴫 
    }
    
    *DMAxCTL |= (srcMode & 0x04) << 2;                  //Դ ֻֽ
    *DMAxCTL |= (srcMode & 0x03) << 8;                  //Դ ַı䷽ʽ
    
    *DMAxCTL |= (dstMode & 0x04) << 3;                  //Ŀ ֻֽ
    *DMAxCTL |= (dstMode & 0x03) << 10;                 //Ŀ ַı䷽ʽ
    
    *DMAxSA = src;
    *DMAxDA = dst;
    *DMAxSZ = size;
    
    *DMAxCTL |= DMAEN;                                  //DMAʹ
}

/************************************************************
* ƣDMAReEnable
*     ܣDMAʹ
*     channel:Ҫʹܵͨ
*   ֵ
* ˵    DMAظģʽһδDMAENλ
            ԶλҪٴδܡظģʽ
            DMAENλλԼ䡣   ظģʽ
            ظδ(single)\ظ鴫(block)\ظͻ
            (interleaved )
*************************************************************/
void DMAReEnable(char channel)
{
    switch (channel)        //ʹܶӦͨ
    {
        case 0: DMA0CTL |= DMAEN;   break;      //0ͨ
        case 1: DMA1CTL |= DMAEN;   break;      //1ͨ
        case 2: DMA2CTL |= DMAEN;   break;      //2ͨ
    }
}

/************************************************************
* ƣDMAStart
*     ܣDMAΪģʽʱô˺DMA䡣
*     channel:Ҫͨ
*   ֵ
* ˵    ԴΪ0000 DMAREQ bit (software trigger)
            ʱҪDMAREQλDMAʼ䡣 ô˺
            ˹ܡ
*************************************************************/
void DMAStart(char channel)
{
    switch (channel)        //ʹܶӦͨ
    {
        case 0: DMA0CTL |= DMAREQ;  break;      //0ͨ
        case 1: DMA1CTL |= DMAREQ;  break;      //1ͨ
        case 2: DMA2CTL |= DMAREQ;  break;      //2ͨ
    }
}
